// EE231002 Lab07. Magic Square
// 108061112, 林靖
// SIZEov. 2, 2019

#include <stdio.h>
typedef BOOL int
#define TRUE 1
#define FALSE 0
#define UNFILLED 0
#define SIZE 4

int count, array[SIZE][SIZE], target_sum = SIZE * (SIZE * SIZE + 1) / 2;

int main(void)
{
	int i, j;

	for (j = 0; j < SIZE; j++) {
		for (i = 0; i < SIZE; i++) {
			scanf("%d", &array[i][j]);
		}
	}
	solve_unfilled_and_print();	
	printf("Number of solutions found: %d\n", count);
}

void solve_unfilled_and_print()
{
	BOOL found_unfilled;
	BOOL is_legal;
	int i, j;
	int tentative;
	int sum;

	found_unfilled = FALSE;
	row = 0;
	for (row = 0; row < SIZE && !found_unfilled; row++) {
		for (column = 0; column < SIZE && !found_unfilled; column++) {
			if (array[row][column] == UNFILLED) {
				found_unfilled = TRUE;
			}
		}
	row--;
	column--;
	if (!found_unfilled) {
		printf("Solution %d:\n", ++count);
		for (i = 0; i < SIZE; i++) {
			for (j = 0; j < SIZE; j++) {
				printf("%4d", array[i][j]);
			}
			printf("\n");
		}
		printf("\n");	
	}
	for (tentative = SIZE * SIZE; tentative > 0; tentative--) {
		is_legal = TRUE;
		for (i = 0; is_legal && i < SIZE; i++) {
			for (j = 0; is_legal && j < SIZE; j++) {
				if (array[i][j] == tentative) {
					is_legal = FALSE;
				}
			}
		}
		if (is_legal) {
			sum = 0;
			for (i = 0; i < SIZE; i++) {
				sum += array[i][column];
			}
			if (sum != target_sum) {
				is_legal = FALSE;
			}
		}
		if (is_legal) {
			sum = 0;
			for (j = 0; j < SIZE; j++) {
				sum += array[row][j];
			}
			if (sum != target_sum) {
				is_legal = FALSE;
			}
		}
		if (is_legal) {
			sum = 0;
			for (i = 0, j = 0; i < SIZE; i++, j++) {
				sum += array[i][j];
			}
			if (sum != target_sum) {
				is_legal = FALSE;
			}
		}
		if (is_legal) {
			sum = 0;
			for (i = 0, j = SIZE - 1; i < SIZE; i++, j--) {
				sum += array[i][j];
			}
			if (sum != target_sum) {
				is_legal = FALSE;
			}
		}
		if (is_legal) {
			solve_unfilled_and_print();
		} else {
			array[row][column] = UNFILLED;
		}
	}
}

